	LIST    P = 16C57, n = 66
        ERRORLEVEL  -302, -306
;
;		Program = LCALL_5x.asm
;		Revision Date:	5-07-94
;                               1-15-97    Compatibility with MPASMWIN 1.40
;
; 
P1_TOP		EQU	0x0000
P1_BOTTOM	EQU	0x01FF
P2_TOP		EQU	0x0200
P2_BOTTOM	EQU	0x03FF
P3_TOP		EQU	0x0400
P3_BOTTOM	EQU	0x05FF
P4_TOP		EQU	0x0600
P4_BOTTOM	EQU	0x07FF
RESET_V		EQU	0x07FF
;
STATUS          EQU     0x03        ; Status Register
PA0             EQU     0x05        ; Program Memory Page Address bit 0
PA1             EQU     0x06        ; Program Memory Page Address bit 0
;
FSR             EQU     0x04        ; FSR Register
RP0             EQU     0x05        ; Direct Addressing Register Bank bit 0
RP1             EQU     0x06        ; Direct Addressing Register Bank bit 0
;
BANK0_T         EQU     0x10
BANK1_T         EQU     0x30
BANK2_T         EQU     0x50
BANK3_T         EQU     0x70
;
		org	P1_TOP
;
P1_CALL_1_V	GOTO	P1_CALL_1
P1_CALL_2_V	GOTO	P1_CALL_2
P1_CALL_3_V	GOTO	P1_CALL_3
P1_CALL_4_V	GOTO	P1_CALL_4
P1_CALL_5_V	GOTO	P1_CALL_5
;
;
D_address	EQU     0x10
F		EQU     1
W		EQU     0
;
     include    <AUTO_PG.MAC>
;
START		CALL	P1_CALL_3
;
LOOP		GOTO	LOOP
;
;
P1_CALL_1
;
    if ( (P1_CALL_1_V & 0x0600) != (P1_CALL_1 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
		NOP
		NOP
P1_CALL_1_END	RETURN
;
    if ( (P1_CALL_1 & 0x0600) != (P1_CALL_1_END & 0x0600) )
       MESSG   "Warning - User Defined: Call routine crosses page boundry"
    endif
;


P1_CALL_2
;
    if ( (P1_CALL_2_V & 0x0600) != (P1_CALL_2 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
		NOP
		NOP
P1_CALL_2_END	RETURN
;
    if ( (P1_CALL_2 & 0x0600) != (P1_CALL_2_END & 0x0600) )
       MESSG   "Warning - User Defined: Call routine crosses page boundry"
    endif
;


P1_CALL_3
;
    if ( (P1_CALL_3_V & 0x0600) != (P1_CALL_3 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
		NOP
		NOP
P1_CALL_3_END	RETURN
;
    if ( (P1_CALL_3 & 0x0600) != (P1_CALL_3_END & 0x0600) )
       MESSG   "Warning - User Defined: Call routine crosses page boundry"
    endif
;

            CALLM       P2_CALL_3_V
            nop
            nop
;
            CALLM       P4_CALL_2_V
            nop
            nop
;
            CALLM       P3_CALL_1_V
            nop
            nop

;
P1_CALL_4
;
    if ( (P1_CALL_4_V & 0x0600) != (P1_CALL_4 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
		NOP
		NOP
P1_CALL_4_END	RETURN
;
    if ( (P1_CALL_4 & 0x0600) != (P1_CALL_4_END & 0x0600) )
       MESSG   "Warning - User Defined: Call routine crosses page boundry"
    endif
;
               nop
               nop

		ADDWF_MAC      D_address, F
		ANDWF_MAC      D_address, F
		BCF_MAC        D_address, 7
		BSF_MAC        D_address, 7
		BTFSC_MAC      D_address, 7
		BTFSS_MAC      D_address, 7
		CLRF_MAC       D_address
		COMF_MAC       D_address, F
		DECF_MAC       D_address, F
		DECFSZ_MAC     D_address, F
		INCF_MAC       D_address, F
		INCFSZ_MAC     D_address, F
		IORWF_MAC      D_address, F
		MOVF_MAC       D_address, F
		MOVWF_MAC      D_address
		RLF_MAC        D_address, F
		RRF_MAC        D_address, F
		SUBWF_MAC      D_address, F
		SWAPF_MAC      D_address, F
		XORWF_MAC      D_address, F
		PAGE_MAC       P1_CALL_4
		BANK_MAC       D_address



P1_CALL_5
;
    if ( (P1_CALL_5_V & 0x0600) != (P1_CALL_5 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
		NOP
		NOP
;
		org	P2_TOP       ; This is to force an intentional User Defined Message
;
		NOP
		NOP
P1_CALL_5_END	RETURN
;
    if ( (P1_CALL_5 & 0x0600) != (P1_CALL_5_END & 0x0600) )
       MESSG   "Warning - User Defined: Call routine crosses page boundry"
    endif
;

P2_CALL_1_V	GOTO	P2_CALL_1
P2_CALL_2_V	GOTO	P2_CALL_2
P2_CALL_3_V	GOTO	P2_CALL_3
P2_CALL_4_V	GOTO	P2_CALL_4
P2_CALL_5_V	GOTO	P2_CALL_5


P2_CALL_1	NOP
		NOP
		RETURN
;
    if ( (P2_CALL_1_V & 0x0600) != (P2_CALL_1 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P2_CALL_2	NOP
		NOP
		RETURN
;
    if ( (P2_CALL_2_V & 0x0600) != (P2_CALL_2 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
            CALLM       P1_CALL_3_V
            nop
            nop

P2_CALL_3	NOP
		NOP
		RETURN
;
    if ( (P2_CALL_3_V & 0x0600) != (P2_CALL_3 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
                GOTOM      P1_CALL_2

;
P2_CALL_4	NOP
		NOP
		RETURN
;
    if ( (P2_CALL_4_V & 0x0600) != (P2_CALL_4 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P2_CALL_5	NOP
		NOP
		RETURN
;
    if ( (P2_CALL_5_V & 0x0600) != (P2_CALL_5 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
        MOVF_MAC     BANK0_T, 0
        MOVWF_MAC    BANK1_T
        MOVF_MAC     BANK2_T, 0
        MOVWF_MAC    BANK3_T

;
		org	P3_TOP
;
P3_CALL_1_V	GOTO	P3_CALL_1
P3_CALL_2_V	GOTO	P3_CALL_2
P3_CALL_3_V	GOTO	P3_CALL_3
P3_CALL_4_V	GOTO	P3_CALL_4
P3_CALL_5_V	GOTO	P3_CALL_5


P3_CALL_1	NOP
		NOP
		RETURN
;
    if ( (P3_CALL_1_V & 0x0600) != (P3_CALL_1 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P3_CALL_2	NOP
		NOP
		RETURN
;
    if ( (P3_CALL_2_V & 0x0600) != (P3_CALL_2 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P3_CALL_3	NOP
		NOP
		RETURN
;
    if ( (P3_CALL_3_V & 0x0600) != (P3_CALL_3 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P3_CALL_4	NOP
		NOP
		RETURN
;
    if ( (P3_CALL_4_V & 0x0600) != (P3_CALL_4 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
		org	P4_TOP
;
P4_CALL_1_V	GOTO	P4_CALL_1
P4_CALL_2_V	GOTO	P4_CALL_2
P4_CALL_3_V	GOTO	P4_CALL_3
P4_CALL_4_V	GOTO	P4_CALL_4
P4_CALL_5_V	GOTO	P4_CALL_5

;
P3_CALL_5	NOP	       ; This is to force an intentional User Defined Message
		NOP
		RETURN
;
    if ( (P3_CALL_5_V & 0x0600) != (P3_CALL_5 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P4_CALL_1	NOP
		NOP
		RETURN
;
    if ( (P4_CALL_1_V & 0x0600) != (P4_CALL_1 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P4_CALL_2	NOP
		NOP
		RETURN
;
    if ( (P4_CALL_2_V & 0x0600) != (P4_CALL_2 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P4_CALL_3	NOP
		NOP
		RETURN
;
    if ( (P4_CALL_3_V & 0x0600) != (P4_CALL_3 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P4_CALL_4	NOP
		NOP
		RETURN
;
    if ( (P4_CALL_4_V & 0x0600) != (P4_CALL_4 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif

;
P4_CALL_5	NOP
		NOP
		RETURN
;
    if ( (P4_CALL_5_V & 0x0600) != (P4_CALL_5 & 0x0600) )
       MESSG   "ERROR - User Defined: CALL VECTOR and CALL routine NOT in same page"
    endif
;
;
		org	RESET_V
;
		GOTO	START		; Goto the begining of the program	

	end
